/*
 * Copyright 2005-2007 WSO2, Inc. (http://wso2.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.admin.ui.action;

import java.io.File;

import org.wso2.solutions.identity.admin.KeystoreUtilAdmin;
import org.wso2.solutions.identity.admin.TokenVerifierServiceAdmin;
import org.wso2.solutions.identity.persistence.dataobject.VerifierServiceIdpDO;
import org.wso2.utils.ServerConfiguration;

import com.opensymphony.xwork2.ActionSupport;

public class AddIdentityProviderAction extends ActionSupport {

    private File certificateFile = null;

    private String certificateFileContentType = null;

    private String certificateFileName = null;

    public String execute() throws Exception {
        return INPUT;
    }

    public String addIDP() throws Exception {
        KeystoreUtilAdmin keyAdmin = new KeystoreUtilAdmin();

        ServerConfiguration serverConfig = ServerConfiguration.getInstance();
        String storeFilePath = serverConfig
                .getFirstProperty("Security.IDPKeyStore.Location");
        String passwd = serverConfig
                .getFirstProperty("Security.IDPKeyStore.Password");
        String type = serverConfig
                .getFirstProperty("Security.IDPKeyStore.Type");
        // RelyingPartyUserKeyStore
        String hostName = keyAdmin.importCert(certificateFile, storeFilePath,
                passwd, type);

        VerifierServiceIdpDO idpdo = new VerifierServiceIdpDO();
        idpdo.setHostName(hostName);
        idpdo.setGlobal(true);

        System.out.println(hostName);

        TokenVerifierServiceAdmin tvsAdmin = new TokenVerifierServiceAdmin();
        tvsAdmin.addVerifierServiceIdpDO(idpdo);
        return SUCCESS;
    }

    public File getCertificateFile() {
        return certificateFile;
    }

    public void setCertificateFile(File certificateFile) {
        this.certificateFile = certificateFile;
    }

    public String getCertificateFileContentType() {
        return certificateFileContentType;
    }

    public String getCertificateFileName() {
        return certificateFileName;
    }

    public void setCertificateFileContentType(String certificateFileContentType) {
        this.certificateFileContentType = certificateFileContentType;
    }

    public void setCertificateFileName(String certificateFileName) {
        this.certificateFileName = certificateFileName;
    }

}
