/*
 * Copyright 2005-2007 WSO2, Inc. (http://wso2.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.admin.ui.action;

import org.apache.struts2.StrutsStatics;
import org.wso2.solutions.identity.admin.ui.UIConstants;
import org.wso2.solutions.identity.persistence.IPPersistenceManager;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.List;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;

public class ShowAddRealmConfigurationAction extends ActionSupport {

    private static final long serialVersionUID = 9004883005928113131L;

    private List configProperties;

    public String execute() throws Exception {

        HttpServletRequest request = (HttpServletRequest) ActionContext
                .getContext().get(StrutsStatics.HTTP_REQUEST);
        String realmClassName = request
                .getParameter(UIConstants.REALM_CLASS_NAME);

        HttpSession session = request.getSession();
        session.setAttribute(UIConstants.REALM_CLASS_NAME, realmClassName);

        IPPersistenceManager db = IPPersistenceManager.getPersistanceManager();

        String configClassName = db.getRealm(realmClassName)
                .getConfigClassName();
        Class configClass = Class.forName(configClassName);
        Method[] methods = configClass.getDeclaredMethods();
        this.configProperties = new ArrayList();
        for (int i = 0; i < methods.length; i++) {
            final String name = methods[i].getName();
            if (name.startsWith("set")) {
                this.configProperties.add(name.substring(3, name.length()));
            }
        }

        session.setAttribute(UIConstants.REALM_CONFIG_PROPERTIES,
                this.configProperties);

        return SUCCESS;
    }

    public List getConfigProperties() {
        return configProperties;
    }

}
