/*
 * Copyright 2005-2007 WSO2, Inc. (http://wso2.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.admin.ui.action;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.wso2.solutions.identity.admin.TokenVerifierServiceAdmin;

import com.opensymphony.xwork2.ActionSupport;

public class ShowTVSRelyingPartiesAction extends ActionSupport {

    private static final long serialVersionUID = 4512108763990783866L;

    private List users;

    public String execute() throws Exception {
        TokenVerifierServiceAdmin admin = new TokenVerifierServiceAdmin();
        String[] userNames = admin.getRelyingPartyUsers();
        users = new ArrayList();
        for (int i = 0; i < userNames.length; i++) {
            users.add(new RPUser(userNames[i]));
        }
        return SUCCESS;
    }

    public List getUsers() {
        return users;
    }

    public class RPUser {
        private String name;

        public RPUser(String username) {
            this.name = username;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }

    }

}
