/*
 * Copyright 2005,2006 WSO2, Inc. http://www.wso2.org
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.wso2.solutions.identity.admin;

import org.apache.axis2.AxisFault;
import org.wso2.solutions.identity.IdentityProviderException;
import org.wso2.solutions.identity.persistence.IPPersistenceManager;
import org.wso2.solutions.identity.persistence.dataobject.ClaimValueDO;

/**
 * Create claim value for a user View all claims of a user. Add/remove claims
 * for a user. Delete all claims of a user.
 */
public class ClaimValueAdmin {

    IPPersistenceManager dbman;

    public ClaimValueAdmin() throws IdentityProviderException {
        dbman = IPPersistenceManager.getPersistanceManager();
    }

    // Crate claim values for a user

    public void createClaimValues(ClaimValueDO value) throws AxisFault {
        try {
            dbman.create(value);
        } catch (IdentityProviderException e) {
            e.printStackTrace();
            throw new AxisFault("IdentityPersistanceException", e);
        }

    }

    public ClaimValueDO[] getClaimValuesForUser(String username) {
        return dbman.getClaimValuesForUser(username);
    }

    public void deleteClaimValue(ClaimValueDO value) {
        dbman.delete(value);
    }

}
