/*
 * Copyright 2005-2007 WSO2, Inc. (http://wso2.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.persistence.dao;

import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.wso2.solutions.identity.persistence.HibernateConfig;
import org.wso2.solutions.identity.persistence.dataobject.ActionDO;

import java.util.List;

public class ActionDAO extends BaseDAO {
    
    
    public ActionDAO(HibernateConfig config) {
        super(config);
    }
    
    public ActionDO[] getAllActions() {
        Session session = hbConfig.getCurrentSession();
        Transaction tx = session.beginTransaction();
        String stmt = "from ActionDO";

        ActionDO[] actions = new ActionDO[0];
        try {
            Query query = session.createQuery(stmt);
            List lst = query.list();
            actions = (ActionDO[]) lst.toArray(new ActionDO[lst.size()]);
            tx.commit();
        } catch (Throwable e) {
            tx.rollback();
            String msg = messages.getMessage("errorAccessActions");
            log.error(msg, e);
            throw new RuntimeException("errorAccessActions", e);
        } finally {
            hbConfig.closeSession();
        }

        return actions;
    }
    
}
