/*
 * Copyright 2005-2007 WSO2, Inc. (http://wso2.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.persistence.dataobject;

import java.util.Set;

public class ActionDO extends AbstractDataObject {

    public final static String ACTION_LOG_IN = "login";

    public final static String ACTION_LOG_OUT = "logout";

    public final static String ACTION_DOWNLAOD_CARD = "downloadCard";

    public static final String[][] INITIAL_ACTIONS = new String[][] {
            { ACTION_LOG_IN, "User log in" },
            { ACTION_LOG_OUT, "User log out" },
            { ACTION_DOWNLAOD_CARD, "Download information card" } };

    private String actionId;

    private String actionDescription;

    private Set userActions;

    public String getActionId() {
        return actionId;
    }

    public void setActionId(String actionId) {
        this.actionId = actionId;
    }

    public String getActionDescription() {
        return actionDescription;
    }

    public void setActionDescription(String actionDescription) {
        this.actionDescription = actionDescription;
    }

    public Set getUserActions() {
        return userActions;
    }

    public void setUserActions(Set userActions) {
        this.userActions = userActions;
    }

}
