/*                                                                             
 * Copyright 2005,2006 WSO2, Inc. http://www.wso2.org
 *                                                                             
 * Licensed under the Apache License, Version 2.0 (the "License");             
 * you may not use this file except in compliance with the License.            
 * You may obtain a copy of the License at                                     
 *                                                                             
 *      http://www.apache.org/licenses/LICENSE-2.0                             
 *                                                                             
 * Unless required by applicable law or agreed to in writing, software         
 * distributed under the License is distributed on an "AS IS" BASIS,           
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.    
 * See the License for the specific language governing permissions and         
 * limitations under the License.                                              
 */
package org.wso2.solutions.identity.sts;

import org.apache.axiom.om.OMElement;
import org.wso2.solutions.identity.IdentityConstants;
import org.wso2.solutions.identity.IdentityProviderConstants;

import javax.xml.namespace.QName;

public class IdentityProviderUtil {

    public static OMElement createRequestedDisplayToken(OMElement parent,
            IdentityProviderData data) {

        return createOMElement(parent, IdentityConstants.NS,
                IdentityProviderConstants.LocalNames.REQUESTED_DISPLAY_TOKEN,
                IdentityConstants.PREFIX);
    }

    public static OMElement createDisplayToken(OMElement parent,
            IdentityProviderData data) {

        OMElement displayElem = createOMElement(parent, IdentityConstants.NS,
                IdentityProviderConstants.LocalNames.DISPLAY_TOKEN,
                IdentityConstants.PREFIX);

        return displayElem;

    }

    public static OMElement createDisplayClaim(OMElement parent,
            String displayTag, String displayValue, String uri) {
        OMElement claimElem = createOMElement(parent, IdentityConstants.NS,
                IdentityProviderConstants.LocalNames.DISPLAY_CLAIM,
                IdentityConstants.PREFIX);

        claimElem.addAttribute("Uri", uri, null);

        OMElement tagElem = createOMElement(claimElem, IdentityConstants.NS,
                IdentityProviderConstants.LocalNames.DISPLAY_TAG,
                IdentityConstants.PREFIX);
        tagElem.setText(displayTag);

        OMElement valElem = createOMElement(claimElem, IdentityConstants.NS,
                IdentityProviderConstants.LocalNames.DISPLAY_VALUE,
                IdentityConstants.PREFIX);
        valElem.setText(displayValue);

        return claimElem;
    }

    private static OMElement createOMElement(OMElement parent, String ns,
            String ln, String prefix) {

        return parent.getOMFactory().createOMElement(new QName(ns, ln, prefix),
                parent);

    }

}
