#ifndef _CSPACE_TVS_H_
#define _CSPACE_TVS_H_

#define CSPACE_TVS_RES_ROOT             "VerifierResponse"
#define CSPACE_TVS_RES_PROPERTY_BUNDLE  "Properties"
#define CSPACE_TVS_RES_PROPERTY         "Property"
#define CSPACE_TVS_RES_PROPERTY_ATTR    "Name"
#define CSPACE_TVS_RES_STATE_ATTR       "State"
#define CSPACE_TVS_RES_ISSUER_INFO      "IssuerInfo"
#define CSPACE_TVS_RES_KEY_INFO         "KeyInfo"
#define CSPACE_TVS_RES_RSA_KEY_VALUE    "RSAKeyValue"
#define CSPACE_TVS_RES_KEY_MODULUS      "Modulus"
#define CSPACE_TVS_RES_KEY_EXPONENT     "Exponent"

/*#define CSPACE_AUTH_STATE_HEADER "cardspace_auth_state"
#define CSPACE_AUTH_STATE_AUTHENTICATED "authenticated"*/

/*above should change respectively to:*/
#define CSPACE_TVS_RES_STATE_HEADER "cardspace_verifier_state"

/* Authentication success state */
#define CSPACE_TVS_RES_STATE_SUCCESS    "success"

/* Authentication failure state */
#define CSPACE_TVS_RES_STATE_FAILURE    "failure"

#define CSPACE_HEADER_PREFIX "cardspace_"

#define invoke_tvs(ctx, node) \
    axis2_svc_client_send_receive((ctx)->svc_client, (ctx)->env, (node))

#define verify_element_name(ctx, ele, name) \
    (strcmp(axiom_element_get_localname((ele), (ctx)->env), (name)) == 0 )

/* A sample TVS response
 *
 * <rp:VerifierResponse xmlns:rp=urn:foo.bar State="success">
 *     <rp:PropertyBundle>
 *         <rp:Property Name="foo1">bar1</rp:Property>
 *         <rp:Property Name="foo2">bar2</rp:Property>
 *         <rp:Property Name="foo3">bar3</rp:Property>
 *         ...
 *     </rp:PropertyBundle>
 *     <rp:IssuerInfo>
 *         <KeyInfo>
 *             <KeyValue>
 *                 <RSAKeyValue>
 *                     <Modulus>fooM</Modulus>"
 *                     <Exponent>barE</Exponent>
 *                 </RSAKeyValue>
 *             </KeyValue>
 *         </KeyInfo>
 *     </rp:IssuerInfo>
 * </rp:VerifierResponse>
 */

#define CSPACE_RP_NAMESPACE "http://ns.wso2.org/relyingparty"

#define CSPACE_TVS_REQ_ROOT "VerifierRequest"
#define CSPACE_TVS_REQ_TOKEN "Token"
#define CSPACE_TVS_REQ_ISSUER "Issuer"

#define CSPACE_TVS_ACTION_VERIFY "urn:verify"

#endif
