#ifndef _MOD_CSPACE_H_
#define _MOD_CSPACE_H_

#include <string.h>
#include <stdio.h>
#include <axis2_client.h>
#include <axiom_document.h>
#include <axiom_node.h>
#include <axiom_stax_builder.h>
#include <axiom_xml_reader.h>
#include <axutil_utils.h>
#include <axutil_env.h>
#include <oxs_ctx.h>
#include <oxs_utility.h>
#include <oxs_key.h>
#include <oxs_asym_ctx.h>
#include <oxs_axiom.h>
#include <oxs_token_encryption_method.h>
#include "http_config.h"
#include "session.h"

#define CSPACE_DEBUG

/*for apache2.0*/
#ifndef ap_http_scheme
#define ap_http_scheme(r) ap_http_method(r)
#endif

#define SUCC 1 
#define FAIL !SUCC

#define CSPACE_DEFAULT_LOGIN_ARG "__mod_cspace_login__"
#define CSPACE_DEFAULT_LOGIN_AMP_ARG "&__mod_cspace_login__"


#define CSPACE_XML_TOKEN "xmlToken="

/*#define CSPACE_VERIFY_SUCCESS 100
#define CSPACE_VERIFY_FAILURE 200*/

#define SESSION_COOKIE "CARDSPACESESSIONID"
#define MAX_SESSION_ID_LEN 128 

#define HTTP_COOKIE_HEADER_OUT "Set-Cookie"
#define HTTP_COOKIE_HEADER_IN  "Cookie"

module AP_MODULE_DECLARE_DATA cspace_module;

typedef struct cspace_dir_cfg {
    apr_pool_t *pool;
    int use_cspace_auth; /*true|false flag*/
    int session; /*true|false flag*/
    int sso; /*true|false flag*/
    char dirspec[256];/*TODO: remove MAGIC numbers*/
    char tvs[1024];
    apr_array_header_t *login_page;
    char session_file[1024];
    /*void *session_ctx;*/ /*of session_ctx_t type*/
} cspace_dir_cfg;

typedef struct cspace_svr_cfg {
    apr_pool_t *pool;
    char *key_file;
    char *session_file;
    /*void *session_ctx;*/ /*of session_ctx_t type*/
    long int session_expire; /*session expire time in seconds*/
} cspace_svr_cfg;

#ifdef CSPACE_DEBUG
#define cfg_svr_printf(st, cfg, nl) cfg_svr_printf_fn((st), (cfg), (nl))
void cfg_svr_printf_fn(const char* st, cspace_svr_cfg *cfg, const char* nl);
#define cfg_dir_printf(st, cfg, nl) cfg_dir_printf_fn((st), (cfg), (nl))
void cfg_dir_printf_fn(const char* st, cspace_dir_cfg *cfg, const char* nl);
#else
#define cfg_svr_printf(st, cfg, nl) 
#define cfg_dir_printf(st, cfg, nl) 
#endif

const command_rec cspace_cmds[10];

void *cspace_svr_cfg_create(apr_pool_t *p, server_rec *s);

void *cspace_svr_cfg_merge(apr_pool_t *p, void *parent_cfg, 
                           void *own_cfg);
 
void *cspace_dir_cfg_create(apr_pool_t *p, char *dirspec);

void *cspace_dir_cfg_merge(apr_pool_t *p, void *parent_cfg,
                           void *own_cfg);

#endif /*_MOD_CSPACE_H_*/
