/*
 * Copyright 2005-2007 WSO2, Inc. (http://wso2.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.relyingparty.service;

import org.apache.axiom.om.OMAbstractFactory;
import org.apache.axiom.om.OMElement;
import org.apache.axiom.om.OMFactory;
import org.apache.axiom.om.impl.builder.StAXOMBuilder;
import org.apache.rahas.RahasConstants;
import org.wso2.solutions.identity.relyingparty.TokenVerifierConstants;
import org.wso2.solutions.identity.relyingparty.TokenVerifierTest;

import javax.xml.namespace.QName;
import javax.xml.stream.XMLInputFactory;
import javax.xml.stream.XMLStreamReader;

import java.io.InputStream;

import junit.framework.TestCase;

public class TokenVerifierServiceTest extends TestCase {
    private String samlTokenPath = "saml.xml";

    public void testService() throws Exception {
        VerifierService service = new VerifierService();
        InputStream is = TokenVerifierTest.class.getClassLoader()
                .getResourceAsStream(samlTokenPath);
        XMLStreamReader parser = XMLInputFactory.newInstance()
                .createXMLStreamReader(is);
        StAXOMBuilder builder = new StAXOMBuilder(parser);
        OMElement assertion = builder.getDocumentElement();

        OMFactory fac = OMAbstractFactory.getOMFactory();
        OMElement rstr = fac.createOMElement(new QName(
                RahasConstants.WST_NS_05_02,
                RahasConstants.LocalNames.REQUEST_SECURITY_TOKEN_RESPONSE));
        OMElement token = fac.createOMElement(new QName(
                TokenVerifierConstants.NS, TokenVerifierConstants.LN_TOKEN));
        rstr.addChild(token);
        token.addChild(assertion);

        OMElement result = service.verify(rstr);

        OMElement issuerInfo = result.getFirstChildWithName(new QName(
                TokenVerifierConstants.NS,
                TokenVerifierConstants.LN_ISSUER_INFO));
        TestCase.assertNotNull(issuerInfo);
        TestCase.assertEquals(issuerInfo.getFirstElement().getLocalName(),
                "KeyInfo");
        System.out.println(result);

    }

}
