/*
 * Copyright 2005-2007 WSO2, Inc. (http://wso2.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.user.ui.action;

import org.apache.struts2.StrutsStatics;
import org.wso2.solutions.identity.admin.RegisteredInfoCardInfoAdmin;
import org.wso2.solutions.identity.persistence.dataobject.RegisteredInfoCardInfoDO;
import org.wso2.solutions.identity.relyingparty.TokenVerifierConstants;
import org.wso2.solutions.identity.user.ui.UIConstants;

import javax.servlet.http.HttpServletRequest;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;

/**
 * Process an info card login
 */
public class InfoCardSubmitAction extends ActionSupport {

    private static final long serialVersionUID = 264026108621800214L;

    public String execute() throws Exception {
        ActionContext context = ActionContext.getContext();
        HttpServletRequest request = (HttpServletRequest) context
                .get(StrutsStatics.HTTP_REQUEST);

        String state = (String) request.getAttribute(TokenVerifierConstants.SERVLET_ATTR_STATE);
        if(state.equals(TokenVerifierConstants.STATE_FAILURE)) {
            return ERROR;
        }
        
        String ppid = (String) request
                .getAttribute("privatepersonalidentifier");
        String issuerInfo = (String) request
                .getAttribute(TokenVerifierConstants.ISSUER_INFO);

        RegisteredInfoCardInfoAdmin admin = new RegisteredInfoCardInfoAdmin();
        RegisteredInfoCardInfoDO info = admin.getInfo(ppid);

        if (info != null && info.getIssuerInfo().equals(issuerInfo)) {
            context.getSession().put(UIConstants.USER, info.getUserId());
            context.getSession().put(UIConstants.PPID, ppid);
        } else {
            return ERROR;
        }
        return SUCCESS;
    }
}
